#ifndef MATCHPSK_H_
#define MATCHPSK_H_

#include "PSKpt.h"
#include "Scan.h"
#include "SimpleRigid.h"

struct pskmatch
{
  PSKpt *f, *m, *b;
  double ratio;
  double range_error;
  int index;
  double sortby;
};

bool matches_less(const pskmatch &l, const pskmatch &r);
void ComputeXFormsPSK(Scan *moving_scan, Scan *fixed_scan, vcl_vector<SimpleRigid> &xforms, vcl_vector<pskmatch> &matches);
void MatchPSK(const KeyVec &fixed, const KeyVec &moving, vcl_vector<pskmatch> &matches);
void RangeMatchPSK2(const Scan *scan1, const Scan *scan2, vcl_vector<pskmatch> &matches);
void ComputePSKXForm(const PSKpt *kFixed, const PSKpt *kMoving, SimpleRigid& xform);

void WritePSKMatches(const vcl_vector<pskmatch> &matches, const KeyVec &fixedkpts, const char *filename);
bool ReadPSKMatches(vcl_vector<pskmatch> &matches, const KeyVec &fixedkpts, const KeyVec &movingkpts, const char *filename);

#endif