#ifndef NODE_H_
#define NODE_H_

#include <vnl/vnl_double_3.h>
#include <vcl_vector.h>
#include <vnl/vnl_double_3x3.h>
#include "vtkSmartPointer.h"

//*****************************************************************************

class PSKNode
{
public:
  PSKNode() {}
  vnl_double_3 point;
  vnl_double_3 normal;
  double intensity;
  vnl_double_3 gradient;
  double laplacian;
         
  vcl_vector<PSKNode *> adjacent;
  vcl_vector<int> triangles;
  
  int index;
  int imgindex1, imgindex2;
  bool manifold;
};

//*****************************************************************************

struct PSKTriangle
{
  PSKTriangle() : a(NULL), b(NULL), c(NULL) {}
  PSKTriangle(PSKNode *a_, PSKNode *b_, PSKNode *c_) : a(a_), b(b_), c(c_) {}
  PSKNode *a, *b, *c;
  vnl_double_3 gradient;
  double area;
};

void ConnectTriangle(PSKTriangle &t, int tindex);
bool RayIntersectTriangle(const PSKTriangle &t, const vnl_double_3 &pt, const vnl_double_3 &dir);

//*****************************************************************************

#endif
