#ifndef PSKPT_H_
#define PSKPT_H_

#include <vcl_vector.h>
#include "keypoint.h"
#include "PSKnode.h"

class PSKpt : public Keypoint
{
public:

  double strength;
  PSKNode *n;
  int id;
};

typedef vcl_vector<vcl_vector<PSKpt *> > KeyVec;

void WriteKeypoint(FILE *file, PSKpt *kp);
void ReadKeypoint(FILE *file, PSKpt *kp);
void WriteKeypoints(const KeyVec &kpts, const char *filename);
void WriteKeypoints(const vcl_vector<PSKpt *> &kpts, const char *filename);
void ReadKeypoints(vcl_vector<PSKpt *> &kpts, const char *filename);
void ReadKeypoints(KeyVec &kpts, const char *filename);
void FreeKeyVec(KeyVec &kv); 
void FreeKeyVec(vcl_vector<PSKpt *> &kv);

//*****************************************************************************



#endif
