#include "parameters.h"
#include <string.h>
#include <vcl_iostream.h>

Parameters *Parameters::_param = NULL;

//*****************************************************************************

Parameters *Parameters::Instance()
{
  if (!_param)
    _param = new Parameters;
  return _param;
}

//*****************************************************************************

Parameters::Parameters()
{
  for (unsigned int i = 0; i < NUM_PARAMS; i++)  
    vars[i] = false; 
  noise = 0.002;
}

//*****************************************************************************

void Parameters::ReadArguments(const char *argv[], int start, int end)
{
  for (int i = start; i < end; i++)
  {
    if (!strcmp(argv[i], "-lk"))
      vars[LOADKEYPOINTS] = true;
    else if (!strcmp(argv[i], "-lrd"))
      vars[LOADRANGEDATA] = true;
    else if (!strcmp(argv[i], "-lix"))
      vars[LOADINITIALXFORMS] = true;
    else if (!strcmp(argv[i], "-lpg"))
      vars[LOADPOINTGRID] = true;
  }
}

//*****************************************************************************

void Parameters::Print() const
{
  vcl_cout << "Load Keypoints: " << vars[LOADKEYPOINTS] << vcl_endl;
  vcl_cout << "Load Range Data: " << vars[LOADRANGEDATA] << vcl_endl;
}

//*****************************************************************************