#ifndef PARAMETERS_H_
#define PARAMETERS_H_

#define NUM_PARAMS 5

class Parameters
{
public:
  
  static Parameters *Instance();
  
  enum Variable { LOADKEYPOINTS = 0, LOADRANGEDATA, LOADINITIALXFORMS, LOADPOINTGRID, LOADMATCHES};
  
  void ReadArguments(const char *argv[], int start, int end);
  
  bool GetVariable(Variable v) { return vars[v]; } const
  void SetVariable(Variable v, bool value) { vars[v] = value; }
  void SetNoise(double n) { noise = n; }
  double GetNoise() const { return noise; }

  void Print() const;

private:

  Parameters();
  static Parameters *_param;
  bool vars[NUM_PARAMS];
  double noise;
};

#endif