#ifndef UTILITIES_H_
#define UTILITIES_H_

#include <vnl/vnl_math.h>
#include <vnl/vnl_double_3.h>
#include <vnl/vnl_double_4.h>
#include <vcl_vector.h>

class Utilities
{
public:

  static vnl_double_3 cartesianToSpherical(const vnl_double_3 &pt);
  static vnl_double_3 sphericalToCartesian(const vnl_double_3 &sphericalPt);
  static void writePoints(const vcl_vector< vnl_double_3 > &pts);
  static int classifyPoint(const vnl_double_3 &normal, double d, const vnl_double_3 &pt);
  static int classifyPoint(const vnl_double_4 &plane, const vnl_double_3 &pt);

};

#endif
