#ifndef MESH_H_
#define MESH_H_

#include "mesh_range_data.h"
#include <vcl_list.h>

class Mesh
{
public:
   
  struct Triangle 
  {
    Triangle(int a, int b, int c)      {
      tri[0] = a;      tri[1] = b;       tri[2] = c;
    }
    int tri[3];
  };  

  Mesh(MeshRangeData *rd);
  ~Mesh(); 

  void WriteToVTP(const char *filename);
  MeshRangeData *GetMeshRangeData() const { return rd; }
  const vcl_list<Triangle> &GetTriangles() const { return triangles; }
  vcl_list<Triangle> &GetTriangles() { return triangles; }
  double GetD() const { return D; }

private:

  void ComputeThreshold();
  double ConsiderTriangle(const vnl_double_3 &a, const vnl_double_3 &b, const vnl_double_3 &c);
  bool CheckTriangle(Triangle &t);
  void Triangulate();
  void RemoveUnstableTriangles();
  void ConsolidatePoints();

  vcl_list<Triangle> triangles;
  MeshRangeData *rd;
  double D;
  
};

#endif