#ifndef MESH_RANGE_DATA_H_
#define MESH_RANGE_DATA_H_

#include "LocationsAndNormals.h"

#include <vcl_map.h>
#include <vnl/vnl_vector_fixed.h>

class MeshRangeData
{
public:
  MeshRangeData();
  ~MeshRangeData();

  bool ReadInScanInfo(const char *directory, const char *scan_name);

  //Access functions
  const vbl_array_2d< int > &get_grid() const { return grid; }
  const vcl_vector<vnl_double_3> &get_points() const { return points; }
  const vcl_vector<vnl_double_3> &get_normals() const { return normals; }
  vbl_array_2d< int > &get_grid() { return grid; }
  vcl_vector<vnl_double_3> &get_points() { return points; }
  const vcl_vector<vnl_vector_fixed<unsigned char, 3> > &get_colors() const { return colors; }
  vcl_vector<vnl_vector_fixed<unsigned char, 3> > &get_colors() { return colors; }

  int getGridWidth() const { return gridWidth; }
  int getGridHeight() const { return gridHeight; }
  int getNumPoints() const { return numpoints; }

  void writePolyData(const char *filename) const;

private:

  ///Read range data from a file, specified by name
  bool processData(const char *filename);
  void load_point_grid(const char *filename, vbl_array_2d<PointRecord> &point_grid);

  int gridWidth, gridHeight;  
  int numpoints;

  vbl_array_2d< int > grid;
  vcl_vector<vnl_double_3> points;
  vcl_vector<vnl_double_3> normals;
  vcl_vector<vnl_vector_fixed<unsigned char, 3> > colors;
};

#endif
