//Eric Smith
#include <iostream>
#include <GL/glut.h>
#include <cmath>

#include "Display.h"
#include "Input.h"

//Utility macros
#define DEGREES_TO_RADIANS(x) (x)*0.017453292
#define RADIANS_TO_DEGREES(x) (x)*57.29577951

//*****************************************************************************

void ReshapeFunction(GLsizei w, GLsizei h)
{
  Data::Inst().window_width = w;
  Data::Inst().window_height = h;
  glViewport(0, 0, w, h);
  
  //Set projection trasnformation to perspective
  glMatrixMode(GL_PROJECTION);
    glLoadIdentity();      
    gluPerspective(45.0f, (GLfloat)w/ (GLfloat)h, 0.1f, 10000.0f);
  glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

//*****************************************************************************

void IdleFunction()
{
  //do nothing!
}

//*****************************************************************************

void TimerFunction(int value)
{
  glutPostRedisplay();
  glutTimerFunc(50, TimerFunction, 0);
}

//*****************************************************************************

void DisplayFunction()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();
    //Set the camera to the correct spot
      gluLookAt(Data::Inst().eyex, Data::Inst().eyey, Data::Inst().eyez,
          Data::Inst().eyex + std::cos(Data::Inst().eyeangle), Data::Inst().eyey + std::sin(Data::Inst().eyeangle), Data::Inst().eyez,
          0.0f, 0.0f, 1.0f);
    if (Data::Inst().drawfixed)
      Data::Inst().fixedmesh.Draw();

    glPushMatrix();
      glMultMatrixf(Data::Inst().xforms[Data::Inst().xform_i].mxform);
      if (Data::Inst().drawmoving)
      {
        Data::Inst().movingmesh.Draw();
       Data::Inst().matches[Data::Inst().xform_i].m->DrawKeypoint(0.0f, 0.0f, 0.5f, 0.0f, 0.0f, 1.0f, 8);
      }
     glPopMatrix();

     if (Data::Inst().drawfixed)
       Data::Inst().matches[Data::Inst().xform_i].f->DrawKeypoint(0.5f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 4);

  glPopMatrix();

  glFlush();
  glutSwapBuffers();
}

//*****************************************************************************

void DrawAxes()
{
  glPushMatrix();
  glPushAttrib(GL_CURRENT_BIT);  //save the current color
    glDisable(GL_DEPTH_TEST);  //disable this so we can draw over everything
    glBegin(GL_LINES);

      //X axis in red
      glColor3f(1.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(1.0f, 0.0f, 0.0f);
      
      //Y axis in green
      glColor3f(0.0f, 1.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 1.0f, 0.0f);

      //Z axis in blue
      glColor3f(0.0f, 0.0f, 1.0f);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 1.0f);  
    glEnd();
    glEnable(GL_DEPTH_TEST);  //enable this again for the rest of the scene
  glPopAttrib();          //return to origional color
  glPopMatrix();
}

//*****************************************************************************
