#ifndef DATA_H_
#define DATA_H_

#include <vcl_string.h>
#include <vcl_vector.h>
#include <vnl/vnl_double_3x3.h>
#include <vnl/vnl_double_3.h>
#include "dispkeypoint.h"

struct xform
{
  float mxform[16];
  float imxform[16];
  vnl_double_3x3 R;
  vnl_double_3 t;
};

struct dispkptmatch
{
  DispKeypoint *f, *m, *b;
  double ratio;
  double range_error;
  int index;
  double sortby;
};

class Data
{
public:
  
  static Data &Inst() {
    static Data instance;
    return instance;
  }

  xform &GetXForm()  { return xforms[xform_i]; }
  vcl_vector<xform> &GetXForms() { return xforms; }
  
  float eyex, eyey, eyez;
  int window_width, window_height;
  float eyeangle;
  vcl_string rootdir;
  int xform_i;
  Mesh fixedmesh, movingmesh;
  bool drawfixed, drawmoving;

  vcl_string fdir, fname;
  vcl_string mdir, mname;
  vcl_vector<xform> xforms;
  vcl_vector<dispkptmatch> matches;

private:

  Data()
  {
    eyex = 0.0f; eyey = 0.0f; eyez = 0.0f;
    window_width = 800; window_height = 600;
    eyeangle = 225.0f * 0.017453292f;
    xform_i = 0;
    drawfixed = true; drawmoving = true;
  }
};


#endif