#ifndef DISPKEYPOINT_H_
#define DISPKEYPOINT_H_

#include <vnl/vnl_double_3.h>
#include <vnl/vnl_float_3.h>

#include "MatchPSK.h"

class DispKeypoint
{
public:

  DispKeypoint() {}
  DispKeypoint(const DispKeypoint &k);
  void DrawKeypoint(float r, float g, float b, float rb, float gb, float bb, float linewidth);
  void DrawFarKeypoint(float r, float g, float b);

  vnl_double_3 ul, ur, ll, lr;
  vnl_double_3 origin, xaxis, yaxis, zaxis;
  double scale;
  vnl_vector_fixed<double, 128> feature_vector;
  int id;

  double dist;
private:

};

void ReadKeypoints(vcl_vector<vcl_vector<DispKeypoint *> > &kpts, const char *filename);
void ReadKeypoint(FILE *file, DispKeypoint *kp);

#endif