#ifndef MESH_H_
#define MESH_H_

#include <vnl/vnl_int_3.h>
#include <vnl/vnl_double_3.h>
#include <vcl_vector.h>
#include <vcl_string.h>

class Mesh
{
public:

  Mesh();
  ~Mesh() {}

  void Draw();
  void LoadMesh(const vcl_string &file); 
  void SetColor(float r, float g, float b, float a);
  void FlipColor();
  void LookAt();

  const vcl_vector<vnl_double_3> &GetPoints() const { return points; }

private:

  vcl_vector<vnl_int_3> triangles;
  vcl_vector<vnl_double_3> points;
  vcl_vector<vcl_vector<unsigned char> > colors;

  bool usesolidcolor;
  float r_, g_, b_, a_;
  int displaylist;
  vnl_double_3 center;
};

#endif